%{
#include "calc_synt.h"
#include "tokens.h"
	extern FILE *yyin;
	extern int yylex();
	int len;	
	char* arithm_tmp;
	int yyparse();
        char txt[50];
	int n;	
	var_list *start=NULL;
	var_list *p=NULL;
	    extern char text[50];
	    extern char chr;
	    void yyerror(char *s);
	%}
	%start list
	%token DIGIT LETTER PLUS MINUS DIV MUL OS ZS ASS PROC AND OR INC DEC NL
	%left OR        
	%left AND        
	%left PLUS MINUS        
	%left MUL DIV PROC        
	%left UMINUS  
	%left OS ZS
	%%    
	list : stat NL
	{ 
	     return(0);
	}	     
	|error
	{
	     yyerrok;
	     return(-1);
	}
	stat : expr
	{
	    (void) printf ("Result: %d\n", $1);
	}
	|LETTER ASS expr
        {
	    p=FindVar(text);
	    itoa($3,txt);
	    if (!p) 
		AddVar(text,txt);
	    else strcpy( p->cval,txt);
	}
	|LETTER INC
	{
	     p=FindVar(text);
	     if (!p)
    	     {
            printf("lidash: Arithmetics error: there's no such variable - %s\n",text);
		yyerrok;		 
		return(-1);
	     }		 
	     else
	     {	
		if (atoi(n,p->cval))
		{
		    n++;
		    itoa(n,txt);
    	    	    strcpy(p->cval,txt);
		
		}
	     } 
	}	     
	|LETTER DEC
	{
	    p=FindVar(text);
	    if (!p)
	    { 
		printf("lidash: Arithmetics error: there's no such variable - %s\n",text);
		yyerrok;
		return(-1);		 
	    } 		  
	    else
	    {
		if (atoi(n,p->cval))
		{
		    n--;
		    itoa(n,txt);
    	    	    strcpy(p->cval,txt);
		}
	    }
	}
	expr : OS expr ZS;
	{
	    $$ = $2;
	}
	|expr PLUS expr
	;               
	{
          $$ = $1 + $3;
      }
      |expr MINUS expr;
      {
          $$ = $1 - $3;
      }
      |expr MUL expr
;               
	{
          $$ = $1 * $3;
      }
      |expr DIV expr
;     {
          $$ = $1 / $3;
      }
	|expr PROC expr;
	{
	    $$ = $1 % $3;
	}
	|expr AND expr;
	{
	    $$ = $1 & $3;
	}
	|expr OR expr;
	{
	    $$ = $1 | $3;
	}
	|DIGIT
	{
	    $$ = yylval;
	}
	%%      
	int arithm_main()
	{
    		yyin=fopen(arithm_tmp,"r");
		yyparse();
		fclose(yyin);
		unlink(arithm_tmp);
		return(1);	
      }
	void yyerror(char *s)
	{
	    printf("lidash: arithmetical error\n");
	    return;
	}
	char * itoa(int n, char str[50])
	{
	//converts an integer (n) to a string (str);
	    int i;
	    int ost,len;
	    len=0;
	    char str1[10];
	    while (n>0)
	    {
		len++;
		ost=n-(n/10)*10;
		str1[len]='0'+ost;
		n/=10;	    
	    }
	    //now reverse the string
	    for (i=0;i<len;i++)
	    {
		str[i]=str1[len-i];
	    }
	    str[len]=0;
	    return(str);
	}
	bool atoi(int &n, char *str)
	{
	    int n1=0;
	    int i;
	    for (i=0;i<strlen(str);i++)
	    {
		if ((str[i]<'0')||(str[i]>'9')) return(false);
		//it's not a number
		n1=n1*10+(str[i]-'0');	
	    }
	    n=n1;
	    return(true);
	}
var_list * FindVar(char * name)
//returns a pointer to the variable
{
	    var_list *p=start;
	    if (p==NULL) return (NULL);	//List is empty
	    do
	{
		if (!strcmp(p->str,name)) 
		return(p);
		p=p->next;
		}while (p!=NULL);
	return(NULL);	//There's no such variable in the list!
}
	void DelVar(char *todel)
	{
	    var_list *p1;
	    if (start->next==NULL)
	    {
		if (!strcmp(start->str,todel))
		{
    		    start=NULL;	//all vars has been deleted
		    return;	    
		}
	    }
	    p=start->next;
	    if (p->next==NULL)
	    {
		if (!strcmp(p->str,todel))
		{
		    start->next=NULL;
		    return;
		}
	    }
	    p1=start;
	    //check first node
	    if (!strcmp(start->str,todel)) 
	    {
		start=start->next;
		return;
	    }
	    while (p!=NULL)
	    {
		if (!strcmp(p->str,todel))
		    p1->next=p->next;
		p1=p;
		p=p->next;
	    }
	}
void AddVar(char name[], char str[])
{
	    var_list *p=start;
	    var_list *n;
	    char *sv;	    
	    n=FindVar(name);
	    if (n!=NULL)
	    {
		if (strlen(str)>strlen(n->cval))
		{
		    sv=(char*)malloc(strlen(str)+1);
		    free(n->cval);
		    n->cval=sv;
		}
		strcpy(n->cval,str);		
		return;
	    }
	    int len=strlen(name)+1;
	    char *s;
	    s=(char*)malloc (len);
	    strcpy(s,name);
	    if (str!=NULL)
	    {
    		int len=strlen(str)+1;
		sv=(char*)malloc (len);
		strcpy(sv,str);
	    } else sv=NULL;
	    if (start==NULL) 	//List is empty
	    {
		start = new (var_list);
		start->next=NULL;
		start->str=s;
		start->cval=sv;
		return;
	    }
	    while (p->next!=NULL) p=p->next;
	    n=new(var_list);
	    n->next=NULL;
	    n->str=s;
	    n->cval=sv;	    
	    p->next=n;
}
void PrintVars()
{
		var_list *p=start;
		if (p==NULL) return;
		while (p!=NULL)
		{
		    printf("%s = %s\n",p->str,p->cval);
		    p=p->next;
		}
}
